"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libview' }"

GraphicsMedium subclass:#WinPrinter
	instanceVariableNames:'printerInfo deviceColors deviceFonts printerDC'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Printing'
!

!WinPrinter primitiveDefinitions!
%{
#define TRACE_ALL_EVENTS      /* */

#define COUNT_RESOURCES       /* */
#define COUNT_BMP_RESOURCES   /* */
#define DEBUG_DELETEOBJECT    /* */
#define DEBUG_DC_REUSE        /* */
#define LOCK_DEBUG

#define ADJUSTWINDOW
#define ALWAYSTRUECOLOR
#define WIN32THREADS

/* #define DEBUGMASK            /* */
#define SET_FOCUS_IN_WINTHREAD
#define SET_CURSOR_IN_WINTHREAD
#define DELAY_ENTER_LEAVE_WHILE_IN_SIZE_MOVE /* */
#define xxBEEP_IN_WINTHREAD    /* */
#define COMPRESS_WINDOWPOSCHANGED

#define USE_DRAW_MUTEX
#define xxLATE_GENERATE_EXPOSE              /* get update region from stx thread */


#undef INT
#define INT WIN_INT
#undef Array
#define Array WIN_Array
#undef Number
#define Number WIN_Number
#undef Method
#define Method WIN_Method
#undef Point
#define Point WIN_Point
#undef Rectangle
/* #define Rectangle WIN_Rectangle */
#undef True
#define True WIN_True
#undef False
#define False WIN_False
#undef Block
#define Block WIN_Block
#undef Context
#define Context WIN_Context
#undef Date
#define Date WIN_Date
#undef Time
#define Time WIN_Time
#undef Delay
#define Delay WIN_Delay
#undef Signal
#define Signal WIN_Signal
#undef Set
#define Set WIN_Set
#undef Process
#define Process WIN_Process
#undef Processor
#define Processor WIN_Processor
#undef Message
#define Message WIN_Message

#include <stdio.h>
#include <errno.h>
/* #include <malloc.h> */
/* #include <math.h> */
/* #include <string.h> */

/*#include <stdarg.h>   */

#ifdef __BORLANDC__
# define NOATOM
# define NOGDICAPMASKS
# define NOMETAFILE
# define NOMINMAX
# define NOOPENFILE
# define NOSOUND
# define NOWH
# define NOCOMM
# define NOKANJI
# define NOCRYPT
# define NOMCX
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# include <shellapi.h>
# include <sys\timeb.h>
# include <dir.h>
#else
# define _USERENTRY /**/
# define NOATOM
# define NOGDICAPMASKS
# define NOMETAFILE
# define NOMINMAX
# define NOOPENFILE
# define NOSOUND
# define NOWH
# define NOCOMM
# define NOKANJI
# define NOCRYPT
# define NOMCX
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
# include <sys\timeb.h>
#endif
#include <commdlg.h>

#include <process.h>

#ifdef __DEF_Array
# undef Array
# define Array __DEF_Array
#endif
#ifdef __DEF_Number
# undef Number
# define Number __DEF_Number
#endif
#ifdef __DEF_Method
# undef Method
# define Method __DEF_Method
#endif
#ifdef __DEF_Point
# undef Point
# define Point __DEF_Point
#endif
#ifdef __DEF_Rectangle
# undef Rectangle
# define Rectangle __DEF_Rectangle
#else
# undef Rectangle
#endif
#ifdef __DEF_Block
# undef Block
# define Block __DEF_Block
#endif
#ifdef __DEF_Context
# undef Context
# define Context __DEF_Context
#endif
#ifdef __DEF_Date
# undef Date
# define Date __DEF_Date
#endif
#ifdef __DEF_Time
# undef Time
# define Time __DEF_Time
#endif
# ifdef __DEF_Set
#  undef Set
#  define Set __DEF_Set
# endif
# ifdef __DEF_Signal
#  undef Signal
#  define Signal __DEF_Signal
# endif
# ifdef __DEF_Delay
#  undef Delay
#  define Delay __DEF_Delay
# endif
# ifdef __DEF_Process
#  undef Process
#  define Process __DEF_Process
# endif
# ifdef __DEF_Processor
#  undef Processor
#  define Processor __DEF_Processor
# endif
# ifdef __DEF_Message
#  undef Message
#  define Message __DEF_Message
# endif

#undef INT
#define INT int

/*
 * some defines - tired of typing ...
 */
#define _HANDLEVal(o)        (HANDLE)(__MKCP(o))
#define _HBITMAPVAL(o)       (HBITMAP)(__MKCP(o))
#define _HWNDVal(o)          (HWND)(__MKCP(o))
#define _HPALETTEVal(o)      (HPALETTE)(__MKCP(o))
#define _HCURSORVal(o)       (HCURSOR)(__MKCP(o))
#define _HGDIOBJVal(o)       (HGDIOBJ)(__MKCP(o))
#define _LOGPALETTEVal(o)    (LOGPALETTE *)(__MKCP(o))
#define _COLORREFVal(o)      (COLORREF)(__MKCP(o))

#define _GCDATA(o)           ((struct gcData *)(__MKCP(o)))

#define WIDECHAR unsigned short

#ifdef LATER
  /* for multi-WIN display support, we need this as an instance var (as below)
   * however, there are many more places, where a single static datum is
   * used currently - therefore dont care for this - at least now.
   */
# define __rootDC             (HDC)(__MKCP(__INST(rootDC)))
#endif

#define ISCONNECTED         1

struct gcData {
    union {
	HDC         __hDC;
	struct gcData *__nextFree;
    } u;
    HWND        hWnd;
    HBITMAP     hBitmap;
    HBITMAP     save_hBitmap;
    HBITMAP     hMask;
    short       clipX;
    short       clipY;
    short       clipW;
    short       clipH;
    char        clipping;
    char        clipByChildren;
    char        bkMode;
    char        bitmapColorBitCount;
    short       maskOrgX;
    short       maskOrgY;
    short       lineWidth;
    short       fontAscent;
    int         lStyle;   /* is lineStyle | joinStyle | capStyle */
    int         rop2;
    int         bitbltrop2;
    COLORREF    fgColor;
    COLORREF    bgColor;
    HFONT       hFont;
    HFONT       save_hFont;
    HPEN        hPen;
    HPEN        save_hPen;
    HBRUSH      hBrush;
    HBRUSH      save_hBrush;
};
#define _hDC u.__hDC

#define WIN32PADDING 32


#ifdef DEBUG
# define DPRINTF(x)              { console_fprintf x;}
# define DFPRINTF(x)             /* { console_fprintf x;} */
#else
# define DPRINTF(x)              /* */
# define DFPRINTF(x)             /* */
#endif


/*
 * globally cached - never released
 */

typedef int (*intf)(int);

/*
 * keep the windows cursor and others local in the HWND struct.
 */

typedef struct {
	HCURSOR         hCursor;
	HBRUSH          viewBgBrush;  /* if that is nil, it has a solid bg color */
	COLORREF        viewBgColor;
	int             eventMask;
	short           flag;         /* LI_ - flags bits */
	short           minWidth;
	short           maxWidth;
	short           minHeight;
	short           maxHeight;
	short           bw;
	unsigned char   iconified;
	unsigned char   viewGravity;
	unsigned char   unmapping;
#if 0
	short           bgOffsX;      /* bg-pattern offset */
	short           bgOffsY;      /* bg-pattern offset */
#endif
	short           mouseX;       /* last mouseX */
	short           mouseY;       /* last mouseY */
	COLORREF        bdColor;
} localWindowInfo;
typedef localWindowInfo *plocalWindowInfo;

typedef struct createWindowInfo {
	localWindowInfo *localWindowInfo;  /* in param */
	HANDLE          newWinHandle;      /* out param */
	char            *windowName;       /* in params */
	char            *className;
	int             winStyleBits;
	int             winStyleBitsEx;
	HANDLE          parentHandle;
	int             x;
	int             y;
	int             dx;
	int             dy;
	HANDLE          hCreateEvent;
	short           infoWasRead;
	unsigned short  sequenceNr;
	unsigned        errCode;
} createWindowInfo;


%}
! !

!WinPrinter class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    I know about the printing API (that is the same as the graphics API,
    which is why I inherit from WinWorkstation).
    You would never want to talk to me directly, as I am used by PrinterContext,
    which is what most programs typically talk to.

    [author:]
	Felix Madrid (fm@exept.de)

    See examples in PrinterContext.
"
! !

!WinPrinter class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.

    "Created: / 28-07-2006 / 19:52:01 / fm"
!

on: aPrinterInfo
|newWinPrinter|
newWinPrinter := self new.
newWinPrinter printerInfo: aPrinterInfo.
^ newWinPrinter

    "Created: / 04-08-2006 / 12:57:06 / fm"
! !

!WinPrinter methodsFor:'accessing'!

depth
    ^ 24
!

deviceColors
    "return the registry keeping track of colors which were allocated
     on this device."

    ^ deviceColors

    "Created: 24.2.1997 / 18:01:41 / cg"
!

deviceFonts
    "return the registry keeping track of fonts which were allocated
     on this device."

    ^ deviceFonts ? #()

    "Modified: / 28-07-2006 / 19:48:23 / fm"
!

getLogicalPixelSizeX
    ^ printerInfo printQuality ? 600

    "Created: / 04-08-2006 / 12:49:40 / fm"
!

getLogicalPixelSizeY
    ^ printerInfo printQuality ? 600

    "Created: / 04-08-2006 / 12:49:29 / fm"
!

height
    ^ height

    "Created: / 28-07-2006 / 18:13:12 / fm"
!

height:something
    height := something.

    "Created: / 28-07-2006 / 18:13:12 / fm"
!

printerDC:something
    printerDC := something.
!

printerInfo: aPrinterInfo
    printerInfo :=aPrinterInfo

    "Created: / 04-08-2006 / 12:54:09 / fm"
!

visualType
    ^ #TrueColor
!

width
    ^ width

    "Created: / 28-07-2006 / 18:13:06 / fm"
!

width:something
    width := something.

    "Created: / 28-07-2006 / 18:13:06 / fm"
! !

!WinPrinter methodsFor:'color stuff'!

colorScaledRed:r scaledGreen:g scaledBlue:b
    "allocate a color with rgb values (0..16rFFFF) - return the color index
     (i.e. colorID)"

%{  /* NOCONTEXT */
    int id, ir, ig, ib;

    if (__bothSmallInteger(r, g) && __isSmallInteger(b)) {
	ir = (__intVal(r) >> 8) & 0xff;
	ig = (__intVal(g) >> 8) & 0xff;
	ib = (__intVal(b) >> 8) & 0xff;

	id = RGB( ir, ig, ib);

	RETURN ( __MKSMALLINT(id) );
    }
%}.
    self primitiveFailed.
    ^ nil
!

setBackground:bgColorIndex in:aGCId
    "set background color to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddressLike(__INST(printerDC))) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(__INST(printerDC)));
	COLORREF bg, oldBg;

	oldBg = GetBkColor(hDC);

	bg = __intVal(bgColorIndex) & 0xffffff;
/*        bg = (COLORREF)st2RGB(__intVal(bgColorIndex),gcData);         */

	if (bg != oldBg) {
	    SetBkColor(hDC, bg);
	}

	RETURN (self);
    }
%}
!

setForeground:fgColorIndex in:gcId
    "set foreground color to be drawn with"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddressLike(__INST(printerDC))) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(__INST(printerDC)));
	COLORREF fg, oldFg;

	oldFg = GetTextColor(hDC);

	fg = __intVal(fgColorIndex) & 0xffffff;
/*        fg = (COLORREF)st2RGB(__intVal(fgColorIndex),gcData);         */

	if (fg != oldFg) {
	    SetTextColor(hDC, fg);
	}

	RETURN (self);
    }
%}
! !

!WinPrinter methodsFor:'drawing'!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:ignoredDrawableId with:aDC
    "draw an arc. If any of x,y, w or h is not an integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

%{
    int __x, __y, w, h;
    float angle1, angle2;
    double f;

    if (__isSmallInteger(startAngle))
	angle1 = (float)(__intVal(startAngle));
    else if (__isFloat(startAngle)) {
	angle1 = (float) __floatVal(startAngle);
    } else if (__isShortFloat(startAngle)) {
	angle1 = __shortFloatVal(startAngle);
    } else goto bad;

    if (__isSmallInteger(angle))
	angle2 = (float)(__intVal(angle));
    else if (__isFloat(angle)) {
	angle2 = (float) __floatVal(angle);
    } else if (__isShortFloat(angle)) {
	angle2 = __shortFloatVal(angle);
    } else goto bad;

    if (angle2 <= 0) {
	RETURN (self);
    }

    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height))
     {
	POINT p;
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	DWORD clr = 0 /* 0xFFFFFFFF */;
	HANDLE prevPen, hPen;
	double xB, yB, xE, yE, xR, yR;
	COLORREF fgColor;

	fgColor = GetTextColor(hDC);
	hPen = CreatePen(PS_SOLID, 1, fgColor);

	w = __intVal(width);
	h = __intVal(height);
	__x = __intVal(x);
	__y = __intVal(y);

	    xR = w / 2;
	    yR = h / 2;
	    if (angle2 - angle1 >= 360) {
		xB = xE = __x + xR + 0.5;
		yB = yE = __y /*+ yR + 0.5*/;
	    } else {
		double sin(), cos();
		float rad1, rad2;

		if (angle1 <= 180)
		  angle1 = 180 - angle1;
		else
		  angle1 = 360 + 180 - angle1;
		angle2 = angle1 - angle2;
		/* sigh - compute the intersections ... */
		rad1 = (angle1 * 3.14159265359) / 180.0;
		rad2 = (angle2 * 3.14159265359) / 180.0;
		xB = cos(rad1) * xR;
		yB = sin(rad1) * yR;
		xE = cos(rad2) * xR;
		yE = sin(rad2) * yR;
		xB = __x + xR - xB + 0.5;
		yB = __y + yR - yB + 0.5;
		xE = __x + xR - xE + 0.5;
		yE = __y + yR - yE + 0.5;
	    }
	    prevPen = SelectObject(hDC, hPen);
	    DPRINTF(("Arc x=%d y=%d w=%d h=%d xB=%d xE=%d yB=%d yE=%d a1=%f a2=%f\n",__x,__y,w,h,(int)xB,(int)xE,(int)yB,(int)yE,angle1,angle2));
	    Arc(hDC,
		__x, __y,
		__x + w, __y + h,
		(int)xB, (int)yB,
		(int)xE, (int)yE);

	    SelectObject(hDC, prevPen);

	RETURN ( self );
    }
    bad: ;
%}.
    self primitiveFailed

    "Created: / 07-08-2006 / 10:40:27 / fm"
    "Modified: / 07-08-2006 / 14:44:21 / fm"
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:ignoredDrawableId with:aDC
    "draw a line. If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x0, y0)
     && __bothSmallInteger(x1, y1)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	COLORREF fgColor;
	HANDLE prevPen, hPen;

	int __x1 = __intVal(x1), __y1 = __intVal(y1);

/*      DPRINTF(("displayLine: %d/%d -> %d/%d\n",
		    __intVal(x0), __intVal(y0),
		    __x1, __y1));
*/

	fgColor = GetTextColor(hDC);
	hPen = CreatePen(PS_SOLID, 1, fgColor);
	prevPen = SelectObject(hDC, hPen);

	MoveToEx(hDC, __intVal(x0), __intVal(y0), NULL);

	LineTo(hDC, __x1, __y1);

	/*
	 * end-point ...
	 */
	LineTo(hDC, __x1+1, __y1);

	SelectObject(hDC, prevPen);


	RETURN ( self );
    }
%}
!

displayPointX:px y:py in:ignoredDrawableId with:aDC
    "draw a point. If x/y are not integers, an error is triggered."

%{  /* NOCONTEXT */
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(px, py)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	POINT p;
	COLORREF fgColor;

	int __x = __intVal(px), __y = __intVal(py);

	fgColor = GetTextColor(hDC);
	SetPixelV(hDC, __x, __y, fgColor);

	RETURN ( self );
    }
%}
!

displayPolygon:aPolygon in:aDrawableId with:aDC
    "draw a polygon, the argument aPolygon is a Collection of individual points,
     which define the polygon.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolygon size.

%{
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddressLike(aDC)
     /* && __isExternalAddress(aDrawableId) */
     && __isSmallInteger(numberOfPoints)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	POINT p;
	DWORD clr = 0 /* 0xFFFFFFFF */;
	HANDLE prevPen, hPen;

	num = __intVal(numberOfPoints);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    px = _point_X(point);
	    py = _point_Y(point);
	    if (! __bothSmallInteger(px, py)) {
		goto fail;
	    }
	}

	hPen = CreatePen(PS_SOLID, 1, clr);
	prevPen = SelectObject(hDC, hPen);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolygon, __MKSMALLINT(i+1));
	    px = _point_X(point);
	    py = _point_Y(point);
	    p.x = __intVal(px);
	    p.y = __intVal(py);
	    if (i == 0) {
		MoveToEx(hDC, p.x, p.y, NULL);
	    } else {
		if (i == (num-1)) {
		    PolylineTo(hDC, &p, 1);
		} else {
		    LineTo(hDC, p.x, p.y);
#ifdef PRE_04_JUN_04
		    /*
		     * end-point ...
		     */
		    LineTo(hDC, p.x+1, p.y);
#endif
		}
	    }
	}
	SelectObject(hDC, prevPen);

	RETURN ( self );
    }
fail: ;
%}

    "Created: / 07-08-2006 / 14:46:55 / fm"
!

displayRectangleX:x y:y width:width height:height in:ignoredDrawableId with:aDC
    "draw a rectangle. If the coordinates are not integers, an error is triggered."

%{
    int w, h;
    int xL, yT;
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));

	xL = __intVal(x);
	yT = __intVal(y);
	w = __intVal(width);
	h = __intVal(height);

	DPRINTF(("displayRectangle: %d/%d -> %d/%d\n", xL, yT, w, h));

	if ((w >= 0) && (h >= 0)) {
	    DWORD clr = 0 /* 0xFFFFFFFF */;
	    COLORREF fgColor;
	    HANDLE prevPen, hPen;

	    fgColor = GetTextColor(hDC);
	    hPen = CreatePen(PS_SOLID, 1, fgColor);

	    prevPen = SelectObject(hDC, hPen);
	    MoveToEx(hDC, xL, yT, NULL);
	    LineTo(hDC, xL+w, yT);       // to top-right
	    LineTo(hDC, xL+w, yT+h);     // to bot-right
	    MoveToEx(hDC, xL, yT, NULL); // back to top-left
	    LineTo(hDC, xL, yT+h);       // to bot-left
	    LineTo(hDC, xL+w+1, yT+h);   // move pen one pixel more

	    SelectObject(hDC, prevPen);
	}
	RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:18:25 / fm"
!

displayString:aString from:index1 to:index2 x:x y:y in:ignoredDrawableId with:aDC opaque:opaque
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
    int nInstBytes;

    if (__isExternalAddressLike(aDC)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y))
    {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	int pX, pY;
	pX = __intVal(x);
	pY = __intVal(y);

	if (opaque == true) {
	    SetBkMode(hDC, OPAQUE);
	} else {
	    SetBkMode(hDC, TRANSPARENT);
	}
	SetTextColor(hDC, 0);
	SetBkColor(hDC, 0xFFFFFFFF);

	cls = __qClass(aString);

	i1 = __intVal(index1) - 1;
	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		goto ret;
	    }

	    cp = _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		if (i2 < n) {
		    cp += i1;
		    DPRINTF(("string1: %s pos=%d/%d l=%d hDC=%x\n", cp, pX, pY,l,hDC));

		    if (l > 32767) {
			l = 32767;
		    }
		    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
			DFPRINTF((stderr, "WinPrinter [warning]: Textout failed. %d\n", GetLastError()));
		    }
		    goto ret;
		}
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;
	    n = __byteArraySize(aString) - nInstBytes;

	    if (__isBytes(aString)) {
		if (i2 < n) {
		    cp += i1;
		    DPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (l > 32767) {
			l = 32767;
		    }
		    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
			DFPRINTF((stderr, "WinPrinter [warning]: Textout failed. %d\n", GetLastError()));
		    }
		    goto ret;
		}
	    }

	    /* Unicode */
	    if (__isWords(aString)) {
		n = n / 2;
		if (i2 < n) {
		    WIDECHAR *w_cp = (WIDECHAR *)cp;

		    w_cp += i1;

		    if (! TextOutW(hDC, pX, pY, w_cp, l)) {
			DFPRINTF((stderr, "WinPrinter [warning]: TextoutW failed. %d\n", GetLastError()));
		    }
		    goto ret;
		}
	    }
	}
ret:
	RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:35:19 / fm"
!

displayString:aString from:index1 to:index2 x:x y:y in:ignoredDrawableId with:aDC opaque:opaque fontAscent:fontAscent
    "draw a sub-string - if opaque is false, draw foreground only; otherwise, draw both
     foreground and background characters.
     If the coordinates are not integers, an error is triggered."

%{  /* NOCONTEXT */
    unsigned char *cp;
    OBJ cls;
    int  i1, i2, l, n;
    int nInstBytes;

    if (__isExternalAddressLike(aDC)
     && __isNonNilObject(aString)
     && __bothSmallInteger(index1, index2)
     && __bothSmallInteger(x, y))
    {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	int pX, pY;
	pX = __intVal(x);
	pY = __intVal(y);
	pY -= __intVal(fontAscent);

	if (opaque == true) {
	    SetBkMode(hDC, OPAQUE);
	} else {
	    SetBkMode(hDC, TRANSPARENT);
	}
	SetTextColor(hDC, 0);
	SetBkColor(hDC, 0xFFFFFFFF);

	cls = __qClass(aString);

	i1 = __intVal(index1) - 1;
	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		goto ret;
	    }

	    cp = _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
		if (i2 < n) {
		    cp += i1;
		    DPRINTF(("string1: %s pos=%d/%d l=%d hDC=%x\n", cp, pX, pY,l,hDC));

		    if (l > 32767) {
			l = 32767;
		    }
		    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
			DFPRINTF((stderr, "WinPrinter [warning]: Textout failed. %d\n", GetLastError()));
		    }
		    goto ret;
		}
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;
	    n = __byteArraySize(aString) - nInstBytes;

	    if (__isBytes(aString)) {
		if (i2 < n) {
		    cp += i1;
		    DPRINTF(("string: %s pos=%d/%d\n", cp, pX, pY));
		    if (l > 32767) {
			l = 32767;
		    }
		    if (! TextOut(hDC, pX, pY, (char *)cp, l)) {
			DFPRINTF((stderr, "WinPrinter [warning]: Textout failed. %d\n", GetLastError()));
		    }
		    goto ret;
		}
	    }

	    /* Unicode */
	    if (__isWords(aString)) {
		n = n / 2;
		if (i2 < n) {
		    WIDECHAR *w_cp = (WIDECHAR *)cp;

		    w_cp += i1;

		    if (! TextOutW(hDC, pX, pY, w_cp, l)) {
			DFPRINTF((stderr, "WinPrinter [warning]: TextoutW failed. %d\n", GetLastError()));
		    }
		    goto ret;
		}
	    }
	}
ret:
	RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 28-07-2006 / 20:35:19 / fm"
!

displayString:aString x:x y:y in:aDrawableId with:aGCId
    "draw a string - draw foreground only.
     If the coordinates are not integers, retry with rounded."

    self
	displayString:aString
	x:x
	y:y
	in:aDrawableId
	with:aGCId
	opaque:false
!

displayString:aString x:x y:y in:aDrawableId with:aGCId opaque:opaque
    "draw a string"

    self displayString:aString
		  from:1
		    to:aString size
		     x:x
		     y:y
		     in:aDrawableId
		     with:aGCId
		     opaque:opaque
!

noClipIn:aWindowId gc:aGCId
    "disable clipping rectangle"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(__INST(printerDC))) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(__INST(printerDC)));

	SelectClipRgn(hDC, NULL);
	RETURN (self);
    }
%}
!

setClipX:clipX y:clipY width:clipWidth height:clipHeight in:ignoredDrawableId gc:aGCId
    "clip to a rectangle"

"
      p--w---
      |     |
      h     |  the clipping rectangle
      |     |
      -------
	  where p = ( clipX, clipY ), w = clipWidth, h = clipHeight
"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(__INST(printerDC))
     && __bothSmallInteger(clipX, clipY)
     && __bothSmallInteger(clipWidth, clipHeight) ) {
	HANDLE hDC;
	int cX, cY, cW, cH;

	hDC = (HANDLE)(__externalAddressVal(__INST(printerDC)));

	cX = __intVal(clipX);
	cY = __intVal(clipY);
	cW = __intVal(clipWidth);
	cH = __intVal(clipHeight);

	{
	    HRGN region = CreateRectRgn(cX, cY, cX + cW, cY + cH);

	    if (region == NULL ) {
		console_fprintf(stderr, "WinWorkstat [warning]: clipping region creation failed\n");
	    } else {
		if (SelectClipRgn(hDC, region) == ERROR ) {
		    console_fprintf(stderr, "WinWorkstat [warning]: select clipping region failed\n");
		}
		DeleteObject(region);
	    }
	}
	RETURN (self);
    }
%}.
    self primitiveFailed
! !

!WinPrinter methodsFor:'font stuf'!

createFontFor:aFontName
    "a basic method for font allocation; this method allows
     any font to be aquired (even those not conforming to
     standard naming conventions, such as cursor, fixed or k14)"

%{
    HGDIOBJ hFont;
    char *fn;

    if (__isString(aFontName) || __isSymbol(aFontName)) {
	fn = __stringVal(aFontName);
	if ((strcmp(fn, "fixed") == 0) || (strcmp(fn, "ANSI_FIXED_FONT") == 0)) {
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	} else if ((strcmp(fn, "variable") == 0) || (strcmp(fn, "ANSI_VAR_FONT") == 0)) {
	    hFont = GetStockObject(ANSI_VAR_FONT);
	} else if ((strcmp(fn, "system") == 0) || (strcmp(fn, "SYSTEM_FONT") == 0)) {
	    hFont = GetStockObject(SYSTEM_FONT);
	} else if ((strcmp(fn, "systemFixed") == 0) || (strcmp(fn, "SYSTEM_FIXED_FONT") == 0)) {
	    hFont = GetStockObject(SYSTEM_FIXED_FONT);
	} else if ((strcmp(fn, "deviceDefault") == 0) || (strcmp(fn, "DEVICE_DEFAULT_FONT") == 0)) {
	    hFont = GetStockObject(DEVICE_DEFAULT_FONT);
	} else {
	    hFont = GetStockObject(ANSI_FIXED_FONT);
	}
	if (hFont) {
	    DPRINTF(("createFontFor:%s -> %x\n", fn, hFont));
	    RETURN ( __MKOBJ(hFont) );
	}
    }
%}.
    ^ nil
!

fontMetricsOf:fontId
    "return a fonts metrics info object"

    |rawData info|

    rawData := Array new:15.
    (self primFontMetricsOf:fontId hdc:printerDC intoArray:rawData) isNil ifTrue:[
	self primitiveFailed.
	^ self
    ].

    rawData at:11 put:#'ms-ansi'.

    info := DeviceWorkstation::DeviceFontMetrics new.
    info
      ascent:(rawData at:1)
      descent:(rawData at:2)
      maxAscent:(rawData at:3)
      maxDescent:(rawData at:4)
      minWidth:(rawData at:5)
      maxWidth:(rawData at:6)
      avgWidth:(rawData at:7)
      minCode:(rawData at:8)
      maxCode:16rFFFF "(rawData at:9)"
      direction:nil
      encoding:(rawData at:11).


    ^ info
!

getDefaultFont
    "return a default font id - used when class Font cannot
     find anything usable"

     ^ self createFontFor:'fixed'
!

getFontWithFamily:familyString face:faceString
	    style:styleArgString size:sizeArg encoding:encodingSym

    "try to get the specified font, if not available, try the next smaller
     font."

    |styleString theName theId xlatedStyle id spacing|

    styleString := styleArgString.

    "special: if face is nil, allow access to X-fonts"
    faceString isNil ifTrue:[
	sizeArg notNil ifTrue:[
	    theName := familyString , '-' , sizeArg printString
	] ifFalse:[
	    theName := familyString
	].
	theName isNil ifTrue:[
	    "
	     mhmh - fall back to the default font
	    "
	    theName := 'fixed'
	].
	theId := self createFontFor:theName.
	theId isNil ifTrue:[
	    theId := self getDefaultFont
	].
	^ theId
    ].

    "/ spacing other than 'normal' is contained as last component
    "/ in style
    styleString notNil ifTrue:[
	((styleString endsWith:'-narrow')
	 or:[styleString endsWith:'-semicondensed']) ifTrue:[
	    |i|
	    i := styleString lastIndexOf:$-.
	    spacing := styleString copyFrom:(i+1).
	    styleString := styleString copyTo:(i-1).
	] ifFalse:[
	    spacing := 'normal'.
	].
    ].

    xlatedStyle := styleString.
    xlatedStyle notNil ifTrue:[
	xlatedStyle := xlatedStyle first asString
    ].

    id := self
	    getFontWithFoundry:'*'
	    family:familyString asLowercase
	    weight:faceString
	    slant:styleString "/ xlatedStyle
	    spacing:spacing
	    pixelSize:nil
	    size:sizeArg
	    registry:'*'
	    encoding:encodingSym.

    id isNil ifTrue:[
	(encodingSym notNil and:[encodingSym ~= '*']) ifTrue:[
	    "/ too stupid: encodings come in both cases
	    "/
	    id := self
		    getFontWithFoundry:'*'
		    family:familyString asLowercase
		    weight:faceString
		    slant:styleString "/ xlatedStyle
		    spacing:spacing
		    pixelSize:nil
		    size:sizeArg
		    registry:'*'
		    encoding:encodingSym asUppercase.
	    id isNil ifTrue:[
		id := self
			getFontWithFoundry:'*'
			family:familyString asLowercase
			weight:faceString
			slant:styleString "/ xlatedStyle
			spacing:spacing
			pixelSize:nil
			size:sizeArg
			registry:'*'
			encoding:encodingSym asLowercase.

		id isNil ifTrue:[
		    id := self
			    getFontWithFoundry:'*'
			    family:familyString asLowercase
			    weight:faceString asLowercase
			    slant:styleString asLowercase
			    spacing:spacing
			    pixelSize:nil
			    size:sizeArg
			    registry:'*'
			    encoding:encodingSym asLowercase.
		]
	    ]
	]
    ].
    ^ id

    "Modified: 24.2.1996 / 22:37:24 / cg"
    "Modified: 4.7.1996 / 11:38:47 / stefan"
!

getFontWithFoundry:foundry family:family weight:weight
	      slant:slant spacing:spc pixelSize:pixelSize size:pointSize
	      registry:registry encoding:encoding

    "get the specified font, if not available, return nil.
     For now, this is a poor (incomplete) emulation of the X code ...
     Individual attributes can be left empty (i.e. '') or nil to match any.

     foundry:   'adobe', 'misc', 'dec', 'schumacher' ... usually '*'
     family:    'helvetica' 'courier' 'times' ...
     weight:    'bold' 'medium' 'demi' ...
     slant:     'r(oman)' 'i(talic)' 'o(blique)'
     spacing:   'narrow' 'normal' semicondensed' ... usually '*'
     pixelSize: 16,18 ... usually left empty
     size:      size in point (1/72th of an inch)
     registry:  iso8859, sgi ... '*'
     encoding:  vendor specific encoding (usually '*')
    "

    "
     Windows-NT/95 allows the creation of a font with the following parameters

	nHeight
	nWidth
	nEscapement
	nOrientation
	fnWeight        FW_DONTCARE, FW_NORMAL, FW_MEDIUM, FW_BOLD, ...
	fdwItalic       TRUE or FALSE
	fdwUnderline    TRUE or FALSE
	fdwStrikeOut    TRUE or FALSE
	fdwCharSet      ANSI_CHARSET, UNICODE_, SYMBOL_, SHIFTJIS_,...
	fdwOutputPrecision      DEFAULT, STRING, CHAR, ...
	fdwClipPrecision        DEFAULT, CHAR, STROKE, MASK, ...
	fdwQuality      DEFAULT, DRAFT, or PROOF.
	fdwPitchAndFamily
		DEFAULT, FIXED or VARIABLE pitch
		DECORATIVE, DONTCASE, MODERN, ROMAN, SCRIPT, or SWISS.
	lpszFace
		Typeface Name

      These two above descriptions will be matched as follows:

	foundry   - ignored
	family    - mapped to type face name.
	weight    - mapped to fnWeight
	slant     - used for style
	spacing   - NOT USED INITIALLY
	pixelSize - NOT USED INITIALLY
	size      - mapped to nHeight
	registry  - NOT USED INITIALLY
	encoding  - mapped to fdwCharSet
     "

    |logSize|

    pixelSize notNil ifTrue:[
	logSize := pixelSize
    ] ifFalse:[
	logSize := (pointSize * (self getLogicalPixelSizeY) / 72.0) rounded.
    ].
%{
    HGDIOBJ hFont;
    int  pointSize, nHeight, nWidth, nEscapement, nOrientation;
    char* work;
    char* work2;
    DWORD fnWeight;
    DWORD fdwItalic;
    DWORD fdwUnderline;
    DWORD fdwStrikeOut;
    DWORD fdwCharSet;
    DWORD fdwOutputPrecision;
    DWORD fdwClipPrecision;
    DWORD fdwQuality;
    DWORD fdwPitchAndFamily;
    static char faceName[256];

/* INITIALIZE */
    strcpy( faceName, "NULL" );
    nHeight   = 0;
    nWidth   = 0;
    nEscapement = 0;
    nOrientation = 0;
    fnWeight = FW_NORMAL;
    fdwItalic = FALSE;
    fdwUnderline = FALSE;
    fdwStrikeOut = FALSE;
    fdwOutputPrecision = OUT_DEFAULT_PRECIS;
    fdwClipPrecision   = CLIP_DEFAULT_PRECIS;
    fdwQuality         = DEFAULT_QUALITY;
    fdwPitchAndFamily  = FF_DONTCARE;

    fdwCharSet   = ANSI_CHARSET;
    if ((encoding == @symbol('ms-ansi'))) {
	fdwCharSet   = ANSI_CHARSET;
    } else if (encoding == @symbol('ms-default')) {
	fdwCharSet   = DEFAULT_CHARSET;
    } else if ((encoding == @symbol('ms-symbol'))
	    || (encoding == @symbol('misc-fontspecific'))) {
	fdwCharSet   = SYMBOL_CHARSET;
    } else if ((encoding == @symbol('ms-shiftjis'))
	    || (encoding == @symbol('jisx0208.1983-0'))){
	fdwCharSet   = SHIFTJIS_CHARSET;
    } else if ((encoding == @symbol('ms-gb2312'))
	    || (encoding == @symbol('gb2312.1980-0'))) {
	fdwCharSet   = GB2312_CHARSET;
    } else if ((encoding == @symbol('ms-hangeul'))
	    || (encoding == @symbol('ksc5601.1987-0'))) {
	fdwCharSet   = HANGEUL_CHARSET;
    } else if ((encoding == @symbol('ms-chinesebig5'))
	    || (encoding == @symbol('big5'))) {
	fdwCharSet   = CHINESEBIG5_CHARSET;
    } else if (encoding == @symbol('ms-oem')) {
	fdwCharSet   = OEM_CHARSET;
    } else if (encoding == @symbol('ms-johab')) {
	fdwCharSet   = JOHAB_CHARSET;
    } else if ((encoding == @symbol('ms-hebrew'))
	    || (encoding == @symbol('ms-cp1255'))) {
	fdwCharSet   = HEBREW_CHARSET;
    } else if ((encoding == @symbol('ms-arabic'))
	    || (encoding == @symbol('ms-cp1256'))) {
	fdwCharSet   = ARABIC_CHARSET;
    } else if ((encoding == @symbol('ms-greek'))
	    || (encoding == @symbol('ms-cp1253'))) {
	fdwCharSet   = GREEK_CHARSET;
    } else if ((encoding == @symbol('ms-turkish'))
	    || (encoding == @symbol('ms-cp1254'))) {
	fdwCharSet   = TURKISH_CHARSET;
    } else if ((encoding == @symbol('ms-russian'))
	    || (encoding == @symbol('ms-cp1251'))) {
	fdwCharSet   = RUSSIAN_CHARSET;
    } else if ((encoding == @symbol('ms-easteurope'))
	    || (encoding == @symbol('ms-cp1250'))) {
	fdwCharSet   = EASTEUROPE_CHARSET;
    } else if ((encoding == @symbol('ms-baltic'))
	    || (encoding == @symbol('ms-cp1257'))) {
	fdwCharSet   = BALTIC_CHARSET;
    } else if ((encoding == @symbol('ms-vietnamese'))) {
	fdwCharSet   = VIETNAMESE_CHARSET;
    } else if ((encoding == @symbol('ms-thai'))) {
	fdwCharSet   = THAI_CHARSET;
    } else if ((encoding == @symbol('ms-mac'))) {
	fdwCharSet   = MAC_CHARSET;
#ifdef UNICODE_CHARSET
    } else if ((encoding == @symbol('ms-unicode'))) {
	fdwCharSet   = UNICODE_CHARSET;
#endif
    }

    if ( __isString( family ) ) {
	work = __stringVal( family );
	if (strcmp( work, "nil" ) != 0 ) {
	    strncpy( faceName, work, sizeof(faceName)-1 );
	}
    }

    /* Q: should we allow those ? (they make ST/X programs less portable to X */
    if( __isString( weight ) ) {
	work = __stringVal( weight );
	if (strcmp( work, "bold" ) == 0 ) {
	    fnWeight = FW_BOLD;
	} else if (strcmp( work, "medium" ) == 0 ) {
	    fnWeight = FW_MEDIUM;
	} else if (strcmp( work, "normal" ) == 0 ) {
	    fnWeight = FW_NORMAL;
	} else if (strcmp( work, "light" ) == 0 ) {
	    fnWeight = FW_LIGHT;
	} else if (strcmp( work, "demi" ) == 0 ) {
	    fnWeight = FW_LIGHT;
	} else if (strcmp( work, "heavy" ) == 0 ) {
	    fnWeight = FW_HEAVY;
	} else if (strcmp( work, "extraBold" ) == 0 ) {
	    fnWeight = FW_EXTRABOLD;
	} else if (strcmp( work, "semiBold" ) == 0 ) {
	    fnWeight = FW_SEMIBOLD;
	} else if (strcmp( work, "thin" ) == 0 ) {
	    fnWeight = FW_THIN;
	} else if (strcmp( work, "extraLight" ) == 0 ) {
	    fnWeight = FW_EXTRALIGHT;
	}
    } else if (__isSmallInteger(weight)) {
	fnWeight = __intVal(weight);
    }

    if(__isSmallInteger( logSize )) {
	nHeight = __intVal( logSize );
    }

    if (__isString(slant)) {
	work2 = __stringVal( slant );
	work  = __stringVal( slant );

	if (strncmp(work2, "italic", 6) == 0)  {
	    fdwItalic = TRUE;
	    if ( work2[6] == '-' )
		strncpy( work, &work2[7], ( strlen( work2) - 7) );
	} else {
	    if (strncmp(work2, "oblique", 7) == 0)  {
		fdwItalic = TRUE;
		if ( work2[7] == '-' )
		    strncpy( work, &work2[8], ( strlen( work2) - 8) );
	    }
	}
	if (strncmp( work, "underline", 9 ) == 0 ) {
	    fdwUnderline = TRUE;
	    if( work[10] == '-' )
		strncpy( work2, &work[11], ( strlen( work ) - 10 ) );
	}
	if (strncmp( work2, "strikeOut", 9 ) == 0 ) {
	    fdwStrikeOut = TRUE;
	}
    }

    DPRINTF(("CreateFont face:%s h=%d w=%d wght=%d\n",
		faceName, nHeight, nWidth, fnWeight));

    hFont = CreateFont( -nHeight,   /* character height - not cell height */
			nWidth,
			nEscapement,
			nOrientation,
			fnWeight,
			fdwItalic,
			fdwUnderline,
			fdwStrikeOut,
			fdwCharSet,
			fdwOutputPrecision,
			fdwClipPrecision,
			fdwQuality,
			fdwPitchAndFamily,
			faceName );

    if (hFont != NULL) {
	DPRINTF(("createFont: %x\n", hFont));
/*
    #ifdef COUNT_RESOURCES
	__cnt_font++;
	RES1PRINTF(("CreateFont %d\n", __cnt_font));
    #endif
*/
	RETURN ( __MKOBJ(hFont) );
    }

    DPRINTF(("***** ERROR createFontWithFoundry failed ERROR *****\n" ));
%}.
    ^ nil

    "
     Display getFontWithFoundry:'*'
			 family:'courier'
			 weight:'medium'
			  slant:'r'
			spacing:nil
		      pixelSize:nil
			   size:13
		       registry:'iso8859'
		       encoding:'*'
    "

    "new NT Version: 20.2.1997 / 22:33:29 / dq"
!

primFontMetricsOf:fontId hdc:aDC intoArray:rawData
    "evaluate aBlock, passing a fonts metrics as arguments.
     fill passed array as:
      ascent     -> (data at:1)
      descent    -> (data at:2)
      maxAscent  -> (data at:3)
      maxDescent -> (data at:4)
      minWidth   -> (data at:5)
      maxWidth   -> (data at:6)
      avgWidth   -> (data at:7).
      minChar    -> (data at:8).
      maxChar    -> (data at:9).
      defaultChar-> (data at:10).
      charSet    -> (data at:11).
"

%{

    if (__isExternalAddress(fontId)
     && __isExternalAddressLike(aDC)
     && __isArray(rawData)
     && (__arraySize(rawData) >= 11)) {
	SIZE size;
	int avgWidth;
	HGDIOBJ hFont;
	HGDIOBJ prevFont;
	TEXTMETRIC tmet;
	static char *s = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	static int len;
	OBJ t;
	HANDLE hDC;

	hFont = _HGDIOBJVal(fontId);
	hDC = (HANDLE)(__externalAddressVal(aDC));

	/*
	 * temporarily set this font in the tmpDC (root-) context
	 */

	prevFont = SelectObject(hDC, hFont);

	GetTextMetricsW(hDC, &tmet);
	if (len == 0) {
	    len = strlen(s);
	}
#if 0
	GetTextExtentPoint32(hDC, s, len, &size);
	avgWidth = (size.cx / (len / 2) + 1) / 2;
#else
	avgWidth = tmet.tmAveCharWidth;
#endif

	__ArrayInstPtr(rawData)->a_element[0] = __MKSMALLINT(tmet.tmAscent);        /* ascent     -> (data at:1) */
	__ArrayInstPtr(rawData)->a_element[1] = __MKSMALLINT(tmet.tmDescent);       /* descent    -> (data at:2) */
	__ArrayInstPtr(rawData)->a_element[2] = __MKSMALLINT(tmet.tmAscent);        /* maxAscent  -> (data at:3) */
	__ArrayInstPtr(rawData)->a_element[3] = __MKSMALLINT(tmet.tmDescent);       /* maxDescent -> (data at:4) */
	__ArrayInstPtr(rawData)->a_element[4] = __MKSMALLINT(avgWidth);             /* minWidth   -> (data at:5) */
	__ArrayInstPtr(rawData)->a_element[5] = __MKSMALLINT(tmet.tmMaxCharWidth);  /* maxWidth   -> (data at:6) */
	__ArrayInstPtr(rawData)->a_element[6] = __MKSMALLINT(avgWidth);             /* avgWidth   -> (data at:7) */
	__ArrayInstPtr(rawData)->a_element[7] = __MKSMALLINT(tmet.tmFirstChar);     /* min        -> (data at:8) */
	__ArrayInstPtr(rawData)->a_element[8] = __MKSMALLINT(tmet.tmLastChar);      /* max        -> (data at:9) */
	__ArrayInstPtr(rawData)->a_element[9] = __MKSMALLINT(tmet.tmDefaultChar);   /* default    -> (data at:10) */
#if 0
	t = __charSetSymbolFor(tmet.tmCharSet);
	__ArrayInstPtr(rawData)->a_element[10]= t; __STORE(rawData, t);             /* charSet    -> (data at:11) */
#endif

	DPRINTF(("textMetrics h=%x  avgAsc=%d avgDesc=%d minW=%d maxW=%d avgW=%d\n",
		    hFont, tmet.tmAscent, tmet.tmDescent, avgWidth, tmet.tmMaxCharWidth,
		    tmet.tmAveCharWidth));

	SelectObject(hDC, prevFont);
	RETURN (self);
    }
    RETURN (nil);
%}
!

widthOf:aString from:index1 to:index2 inFont:aFontId

%{  /* NOCONTEXT */
    unsigned char *cp;
    int len, n, i1, i2, l;
    OBJ cls;
    int nInstBytes;

    if (__bothSmallInteger(index1, index2)
     && __isExternalAddress(aFontId)
     && __isExternalAddressLike(__INST(printerDC))
     && __isNonNilObject(aString)) {
	HGDIOBJ hFont,prevFont;
	HANDLE hDC;
	SIZE tsize;

#ifndef PRE_22_FEP_2007
#       define N_QUICK_CHARS    1024
	unsigned short quickWchars[N_QUICK_CHARS];
	unsigned short *wcharPtr;
	int mustFree = 0;
	int i;
#endif

	hFont = _HGDIOBJVal(aFontId);
	hDC = (HANDLE)(__externalAddressVal(__INST(printerDC)));

	prevFont = SelectObject(hDC, hFont);

	i1 = __intVal(index1) - 1;
	cls = __qClass(aString);

	if (i1 >= 0) {
	    i2 = __intVal(index2) - 1;
	    if (i2 < i1) {
		RETURN ( __MKSMALLINT( 0 ) );
	    }

	    cp = (char *) _stringVal(aString);
	    l = i2 - i1 + 1;

	    if ((cls == @global(String)) || (cls == @global(Symbol))) {
		n = _stringSize(aString);
    commonWidthChars:
		if (i2 < n) {
		    cp += i1;

#ifdef PRE_22_FEP_2007
		    GetTextExtentPoint32(hDC, cp, l, &tsize);
#else
		    if (l <= N_QUICK_CHARS) {
			wcharPtr = quickWchars;
			mustFree = 0;
		    } else {
			wcharPtr = malloc(sizeof(short)*l);
			if (! wcharPtr) RETURN (__MKSMALLINT(0));
			mustFree = 1;
		    }
		    for (i=0; i<l; i++) wcharPtr[i] = ((unsigned char *)cp)[i];
		    GetTextExtentPoint32W(hDC, wcharPtr, l, &tsize);
		    if (mustFree) free(wcharPtr);
#endif

#ifdef SUPERDEBUG
		    if (__debug__) {
			char buf[80];

			GetTextFace(hDC,80,buf);
			console_printf("font1 %x %s >%s< l=%d dx=%d\n",hFont,buf,cp,l,tsize.cx);
		    }
#endif
		    SelectObject(hDC, prevFont);
		    RETURN ( __MKSMALLINT(tsize.cx) );
		}
		RETURN (__MKSMALLINT(0));
	    }

	    nInstBytes = __OBJS2BYTES__(__intVal(__ClassInstPtr(cls)->c_ninstvars));
	    cp += nInstBytes;
	    n = __byteArraySize(aString) - nInstBytes;

	    if (__isBytes(aString)) {
		goto commonWidthChars;
	    }

	    /* Unicode */
	    if (__isWords(aString)) {
		n = n / 2;
		if (i2 < n) {
		    WIDECHAR *w_cp = (WIDECHAR *)cp;

		    w_cp += i1;

		    GetTextExtentPoint32W(hDC, w_cp, l, &tsize);
		    SelectObject(hDC, prevFont);
		    RETURN ( __MKSMALLINT(tsize.cx) );
		}
		RETURN (__MKSMALLINT(0));
	    }
	}
    }
%}.
    self primitiveFailed.
    ^ 0
!

widthOf:aString inFont:aFontId
    "return the width in pixels of a string in a specific font"

    ^ self widthOf:aString from:1 to:(aString size) inFont:aFontId
! !

!WinPrinter methodsFor:'graphic context stuff'!

setBitmapMask:aBitmapId in:aDC
    "set or clear the drawing mask - a bitmap mask using current fg/bg"

    self todo.

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(aDC)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	HBITMAP oldM;

/*        oldM = gcData->hMask;
	if (__isExternalAddress(aBitmapId))
	    gcData->hMask = _HBITMAPVAL(aBitmapId);
	else
	    gcData->hMask = 0;

	if (oldM != gcData->hMask) {
	  FLUSH_CACHED_DC(gcData);
	    CPRINTF(("masks set to %x\n",gcData->hMask));
	}                                                     */
	RETURN (self);
    }
%}
!

setDashes:dashList dashOffset:offset in:aGCId
    "set line attributes"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(aGCId)) {
	DPRINTF(("WinWorkstat [warning]: dashes not (yet) implemented\n"));
    }
%}
!

setFont:aFontId in:aDC
    "set font to be drawn in"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(aDC)
     && __isExternalAddress(aFontId))
    {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	HGDIOBJ prevFont, hFont;

	hFont = _HGDIOBJVal(aFontId);
	prevFont = SelectObject(hDC, hFont);

	RETURN ( self );
    }
%}.
    self primitiveFailed

    "Created: / 04-08-2006 / 12:32:53 / fm"
!

setForeground:fgColorIndex background:bgColorIndex in:aDC
    "set foreground and background colors to be drawn with"

%{  /* NOCONTEXT */

    if (__isExternalAddressLike(aDC)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	COLORREF fg, bg, oldFg, oldBg;

/*        fg = (COLORREF)st2RGB(__intVal(fgColorIndex),gcData);    */
	fg = __intVal(fgColorIndex) & 0xffffff;
/*        bg = (COLORREF)st2RGB(__intVal(bgColorIndex),gcData);    */
	bg = __intVal(bgColorIndex) & 0xffffff;

	oldFg = GetTextColor(hDC);
	oldBg = GetBkColor(hDC);

	if ((fg != oldFg) || (bg != oldBg)) {
	    /* Pen only depends upon fg-color */
	    if (fg != oldFg) {
		SetTextColor(hDC, fg);
	    }
	    if (bg != oldBg) {
		SetBkColor(hDC, bg);
	    }
	}
	RETURN (self);
    }
%}
!

setLineWidth:aNumber style:lineStyle cap:capStyle join:joinStyle in:aGCId
    "set line attributes"

%{  /* NOCONTEXT */

    HDC hDC;

    if (__isExternalAddressLike(__INST(printerDC))
     && __isSmallInteger(aNumber)) {
	HANDLE hDC = (HANDLE)(__externalAddressVal(__INST(printerDC)));
	int style;

	if (lineStyle == @symbol(solid)) {
	    style = PS_SOLID;
	} else if (lineStyle == @symbol(dashed)) {
	    style= PS_DASH;
	} else if (lineStyle == @symbol(dotted)) {
	    style= PS_DOT;
	} else if (lineStyle == @symbol(dashDot)) {
	    style= PS_DASHDOT;
	} else if (lineStyle == @symbol(dashDotDot)) {
	    style= PS_DASHDOTDOT;
	} else
	    style= PS_SOLID;

	if (capStyle == @symbol(round)) {
	    style = PS_ENDCAP_ROUND;
	} else if (capStyle == @symbol(square)) {
	    style = PS_ENDCAP_SQUARE;
	} else if (capStyle == @symbol(flat)) {
	    style = PS_ENDCAP_FLAT;
	} else
	    style = PS_ENDCAP_FLAT;

	if (joinStyle == @symbol(bevel)) {
	    style = PS_JOIN_BEVEL;
	} else if (joinStyle == @symbol(miter)) {
	    style = PS_JOIN_MITER;
	} else if (joinStyle == @symbol(round)) {
	    style = PS_JOIN_ROUND;
	} else
	    style = PS_JOIN_MITER;

	RETURN (self);
    }
%}.
    self primitiveFailed
! !

!WinPrinter methodsFor:'initialization'!

initialize
    self initializeDeviceResourceTables

    "Modified: / 28-07-2006 / 19:52:07 / fm"
!

initializeDeviceResourceTables
"/    deviceViews := Registry new.
"/    deviceForms := Registry new.
    deviceColors := Registry new.
"/    deviceCursors := Registry new.
    deviceFonts := CachingRegistry new cacheSize:10.

    "Created: 24.2.1997 / 18:29:53 / cg"
!

releaseDeviceColors
    deviceColors do:[:aColor |
	aColor releaseFromDevice
    ].
    deviceColors := Registry new.

    "TrueColors are not registered.
     Release the the hard way"
    Color flushDeviceColorsFor:self.

    "Created: 24.2.1997 / 18:07:49 / cg"
!

releaseDeviceFonts
    deviceFonts do:[:aFont |
	aFont releaseFromDevice.
    ].
    deviceFonts := CachingRegistry new cacheSize:10.
! !

!WinPrinter methodsFor:'no supported yet'!

displayPolylines:aPolyline in:ignoredDrawableId with:aDC
    "draw a polyline, the argument aPolyline is a collection of individual points,
     which define the lines (p1/p2 pairs); must be even in size.
     If any coordinate is not integer, an error is triggered."

    |numberOfPoints|

    numberOfPoints := aPolyline size.

%{
    OBJ point, px, py;
    int i, num;

    if (__isExternalAddressLike(aDC)
     && __isSmallInteger(numberOfPoints)) {

	HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	POINT p;
	DWORD clr = 0 /* 0xFFFFFFFF */;
	HANDLE prevPen, hPen;

	num = __intVal(numberOfPoints);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolyline, __MKSMALLINT(i+1));
	    if (! __isPoint(point)) goto fail;
	    px = _point_X(point);
	    py = _point_Y(point);
	    if (! __bothSmallInteger(px, py)) {
		goto fail;
	    }
	}

	hPen = CreatePen(PS_SOLID, 1, clr);
	prevPen = SelectObject(hDC, hPen);

	for (i=0; i<num; i++) {
	    point = __AT_(aPolyline, __MKSMALLINT(i+1));
	    px = _point_X(point);
	    py = _point_Y(point);
	    p.x = __intVal(px);
	    p.y = __intVal(py);
	    DPRINTF(("printing point"));
	    DPRINTF(("displayPolygon: no pen\n"));

	    if ((i & 1) == 0) {
		MoveToEx(hDC, p.x, p.y, NULL);
	    } else {
		LineTo(hDC, p.x, p.y);
		/*
		 * end-point ...
		 */
		LineTo(hDC, p.x+1, p.y);
	    }
	}
	SelectObject(hDC, prevPen);

	RETURN ( self );
    }
fail: ;
%}
!

fillArcX:x y:y width:width height:height from:startAngle angle:angle
	       in:ignoredDrawableId with:aGCId
    "fill an arc. If any coordinate is not integer, an error is triggered.
     The angles may be floats or integer - they are given in degrees."

    self todo.

"/%{
"/    int __x, __y, w, h;
"/    float angle1, angle2;
"/
"/    if (__isSmallInteger(startAngle))
"/        angle1 = (float)(__intVal(startAngle));
"/    else if (__isFloat(startAngle)) {
"/        angle1 = __floatVal(startAngle);
"/    } else if (__isShortFloat(startAngle)) {
"/        angle1 = __shortFloatVal(startAngle);
"/    } else goto bad;
"/
"/    if (__isSmallInteger(angle))
"/        angle2 = (float)(__intVal(angle));
"/    else if (__isFloat(angle)) {
"/        angle2 = __floatVal(angle);
"/    } else if (__isShortFloat(angle)) {
"/        angle2 = __shortFloatVal(angle);
"/    } else goto bad;
"/
"/    if (angle2 <= 0) {
"/        RETURN (self);
"/    }
"/
"/    if (__isExternalAddress(aGCId)
"/     && __bothSmallInteger(x, y)
"/     && __bothSmallInteger(width, height))
"/     {
"/        struct gcData *gcData = _GCDATA(aGCId);
"/        HDC hDC;
"/        HBRUSH hBrush;
"/        HPEN prevPen = 0;
"/
"/        w = __intVal(width);
"/        h = __intVal(height);
"/        __x = __intVal(x);
"/        __y = __intVal(y);
"/
"/        hDC = _getDC(gcData);
"/
"/        hBrush = GcDataGetBrush(hDC, gcData);
"/        if (hBrush == 0) {
"/            DPRINTF(("fillArc: no brush\n"));
"/        } else {
"/            HPEN hPen = 0;
"/
"/            if (0 /* __isWinNT */) {
"/                hPen = GcDataGetPen(hDC, gcData);
"/                if (hPen == 0) {
"/                    DPRINTF(("fillArc: no pen\n"));
"/                    goto failpen;
"/                }
"/            } else {
"/                prevPen = SelectObject(hDC, __nullPen);
"/                w++;
"/                h++;
"/            }
"/
"/            {
"/                double xB, yB, xE, yE, xR, yR;
"/
"/                xR = w / 2;
"/                yR = h / 2;
"/                if (angle2 - angle1 >= 360) {
"/                    xB = xE = __x + xR + 0.5;
"/                    yB = yE = __y /*+ yR + 0.5*/;
"/                } else {
"/                    double sin(), cos();
"/                    float rad1, rad2;
"/
"/                    if (angle1 <= 180)
"/                        angle1 = 180 - angle1;
"/                    else
"/                        angle1 = 360 + 180 - angle1;
"/                    angle2 = angle1 - angle2;
"/                    /* sigh - compute the intersections ... */
"/                    rad1 = (angle1 * 3.14159265359) / 180.0;
"/                    rad2 = (angle2 * 3.14159265359) / 180.0;
"/                    xB = cos(rad1) * xR;
"/                    yB = sin(rad1) * yR;
"/                    xE = cos(rad2) * xR;
"/                    yE = sin(rad2) * yR;
"/                    xB = __x + xR - xB + 0.5;
"/                    yB = __y + yR - yB + 0.5;
"/                    xE = __x + xR - xE + 0.5;
"/                    yE = __y + yR - yE + 0.5;
"/                }
"/                DPRINTF(("fillArc x=%d y=%d w=%d h=%d xB=%d xE=%d yB=%d yE=%d a1=%f a2=%f\n",__x,__y,w,h,(int)xB,(int)xE,(int)yB,(int)yE,angle1,angle2));
"/
"/                Pie(hDC,
"/                    __x, __y,
"/                    __x + w + 1, __y + h + 1,
"/                    (int)xB, (int)yB,
"/                    (int)xE, (int)yE);
"/
"/                if (hPen) {
"/                    GcDataReleasePen(hDC, gcData);
"/                }
"/            }
"/failpen:
"/#ifdef CACHE_LAST_CG
"/            if (prevPen) SelectObject(hDC, prevPen);
"/#endif
"/            GcDataReleaseBrush(hDC, gcData);
"/        }
"/#ifndef CACHE_LAST_DC
"/        _releaseDC(gcData);
"/#endif
"/        RETURN ( self );
"/    }
"/    bad: ;
"/%}.
"/    self primitiveFailed
!

fillRectangleX:x y:y width:width height:height in:ignoredDrawableId with:aDC
    "fill a rectangle. If any coordinate is not integer, an error is triggered."

%{  /* NOCONTEXT */

    int w, h;
    if (__isExternalAddressLike(aDC)
     && __bothSmallInteger(x, y)
     && __bothSmallInteger(width, height)) {
	w = __intVal(width);
	h = __intVal(height);

	if ((w >= 0) && (h >= 0)) {
	    HANDLE hDC = (HANDLE)(__externalAddressVal(aDC));
	    HBRUSH hBrush;
	    RECT rct;
	    COLORREF fgColor;
	    HPEN prevPen;

	    fgColor = GetTextColor(hDC);
	    hBrush = CreateSolidBrush(fgColor);
	    rct.left = __intVal(x);
	    rct.top  = __intVal(y);
	    rct.right  = rct.left + w + 1;
	    rct.bottom = rct.top  + h + 1;

/*                if ((gcData->rop2 == R2_COPYPEN)
		 && (gcData->bitbltrop2 == BITBLT_COPY)) {
		    AQUIRE_DRAW_MUTEX
		    FillRect(hDC, &rct, hBrush);
		    RELEASE_DRAW_MUTEX
		    GcDataReleaseBrush(hDC, gcData);
		} else {
*/
	   prevPen = SelectObject(hDC, hBrush);
# undef Rectangle
	   Rectangle(hDC, rct.left, rct.top, rct.right, rct.bottom);
	   DeleteObject(hBrush);
		    /* GcDataReleaseBrush(hDC, gcData);     */
	   SelectObject(hDC, prevPen);
/*
		}
*/
	    }
	}
	RETURN ( self );
%}
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth padding:padd
			      width:imageWidth height:imageHeight
				  x:srcx y:srcy
			       into:ignoredDrawableId
				  x:dstx y:dsty
			      width:w height:h
			       with:aGCId

    "since XPutImage may allocate huge amount of stack space
     (some implementations use alloca), this must run with unlimited stack."

    self todo.

"/%{
"/    unsigned char fastBits[10000];
"/    unsigned char *b_bits = 0;
"/    unsigned char *allocatedBits = 0;
"/    struct gcData *gcData = 0;
"/    HDC hDC = (HDC)0;
"/    unsigned char *__imageBits = 0;
"/
"/    if (__isByteArray(imageBits)) {
"/        __imageBits = __ByteArrayInstPtr(imageBits)->ba_element;
"/    } else if (__isExternalBytesLike(imageBits)) {
"/        __imageBits = (unsigned char *)(__externalBytesAddress(imageBits));
"/    }
"/
"/    if (ISCONNECTED
"/     && __isExternalAddress(aGCId)
"/     && __bothSmallInteger(srcx, srcy)
"/     && __bothSmallInteger(dstx, dsty)
"/     && __bothSmallInteger(w, h)
"/     && __bothSmallInteger(imageWidth, imageHeight)
"/     && __bothSmallInteger(imageDepth, bitsPerPixel)
"/     && __isSmallInteger(padd)
"/     && __imageBits)
"/     {
"/        struct
"/        {
"/          BITMAPINFOHEADER bmiHeader;
"/          DWORD r;
"/          DWORD g;
"/          DWORD b;
"/        } bitmap;
"/
"/        gcData = _GCDATA(aGCId);
"/        if (! gcData )
"/            goto fail;
"/        hDC = _getDC(gcData);
"/        DDPRINTF(("hDC = %x\n", hDC));
"/
"/        if (__intVal(padd) != WIN32PADDING) {
"/            int row, col;
"/            unsigned char *cp;
"/            unsigned char *pBits;
"/            int b_width, b_height, bytesPerRowST, bytesPerRowWN, padding, nBytes;
"/            int bi = __intVal(bitsPerPixel);
"/
"/            b_width = __intVal(w);
"/            b_height = __intVal(h);
"/            bytesPerRowST = (b_width * bi + (__intVal(padd)-1)) / __intVal(padd);
"/            bytesPerRowWN = (b_width * bi + (WIN32PADDING-1)) / WIN32PADDING * (WIN32PADDING/8);
"/            padding = bytesPerRowWN - bytesPerRowST;
"/            nBytes = b_height * bytesPerRowWN;
"/            /*console_printf("padd %d bs %d bw %d p %d\n",__intVal(padd),bytesPerRowST,bytesPerRowWN,padding);*/
"/            if (padding) {
"/                if (nBytes < sizeof(fastBits)) {
"/                    cp = b_bits = fastBits;
"/                } else {
"/                    cp = b_bits = allocatedBits = (unsigned char *) malloc(nBytes);
"/                }
"/                if (cp) {
"/                    pBits = __imageBits;
"/                    for (row = b_height; row; row--) {
"/                        for (col = bytesPerRowST; col; col--) {
"/                            *cp++ = *pBits++;
"/                        }
"/                        cp += padding;
"/                    }
"/                } else
"/                    goto fail;
"/            }
"/        }
"/
"/        if (b_bits == 0) {
"/            b_bits = __imageBits;
"/        }
"/
"/        bitmap.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
"/        bitmap.bmiHeader.biPlanes = 1;
"/        if (__intVal(imageDepth) == 24) {
"/            /*bitmap.bmiHeader.biCompression = BI_BITFIELDS;
"/            bitmap.r = 0xff0000;
"/            bitmap.g = 0x00ff00;
"/            bitmap.b = 0x0000ff;*/
"/            bitmap.bmiHeader.biCompression = BI_RGB;
"/        } else if (__intVal(imageDepth) == 16) {
"/            /*bitmap.bmiHeader.biCompression = BI_RGB;
"/            bitmap.bmiHeader.biCompression = BI_BITFIELDS;
"/            bitmap.b = 0x001f;
"/            bitmap.g = 0x07e0;
"/            bitmap.r = 0xf800;*/
"/            bitmap.b = 0;
"/            bitmap.g = 0;
"/            bitmap.r = 0;
"/            bitmap.bmiHeader.biCompression = BI_RGB;
"/        }
"/        bitmap.bmiHeader.biSizeImage = 0;
"/        bitmap.bmiHeader.biXPelsPerMeter = 0;
"/        bitmap.bmiHeader.biYPelsPerMeter = 0;
"/        bitmap.bmiHeader.biClrUsed = 0;
"/        bitmap.bmiHeader.biClrImportant = 0;
"/        bitmap.bmiHeader.biWidth = __intVal(imageWidth);
"/        bitmap.bmiHeader.biHeight = -(__intVal(imageHeight));
"/        bitmap.bmiHeader.biBitCount = __intVal(bitsPerPixel);
"/        /*console_printf("drawBits depth:%d bitsPerPixel:%d IW%d W:%d H:%d\n",__intVal(imageDepth),bitmap.bmiHeader.biBitCount,bitmap.bmiHeader.biWidth,__intVal(w),bitmap.bmiHeader.biHeight);*/
"/        SetDIBitsToDevice(hDC,__intVal(dstx),__intVal(dsty),
"/                              __intVal(w), __intVal(h),
"/                              __intVal(srcx), __intVal(srcy),
"/                              0,__intVal(h),
"/                              (void *)b_bits,
"/                              (BITMAPINFO*)&bitmap,DIB_RGB_COLORS);
"/        if (allocatedBits) {
"/            free(allocatedBits);
"/        }
"/#ifndef CACHE_LAST_DC
"/        _releaseDC(gcData);
"/#endif
"/        RETURN ( true );
"/    }
"/
"/fail: ;
"/    PRINTF(("create temp bitmap FAILED!!!\n"));
"/    if (allocatedBits) {
"/        PRINTF(("freeing up temp bitmap bits ...\n"));
"/        free(allocatedBits);
"/    }
"/#ifndef CACHE_LAST_DC
"/    if (hDC) {
"/        _releaseDC(gcData);
"/    }
"/#endif
"/%}
"/.
"/    ^ false
! !

!WinPrinter methodsFor:'registration'!

registerColor:aColor
    deviceColors register:aColor.

    "Created: 24.2.1997 / 18:29:10 / cg"
!

registerFont:aFont
    deviceFonts register:aFont.

    "Created: 24.2.1997 / 18:29:10 / cg"
!

unregisterColor:aColor
    deviceColors unregister:aColor.

    "Created: 24.2.1997 / 18:29:14 / cg"
!

unregisterFont:aFont
    deviceFonts unregister:aFont.

    "Created: 24.2.1997 / 18:29:14 / cg"
! !

!WinPrinter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/WinPrinter.st,v 1.16 2007-04-18 12:52:30 cg Exp $'
! !
